
(*
 * powHelp : int * int * int -> int 
 * REQUIRES: k >= 0
 * ENSURES: powHelp (n, k, acc) ==> acc * n^k (where 0^0 is defined as 1)
 *)
fun powHelp (n:int, k:int, acc:int) : int =
  case k of 
      0 => acc 
    | _ => powHelp (n, k - 1, n * acc)


val 1 = powHelp (5, 0, 1)
val 5 = powHelp (0, 0, 5)
val 75 = powHelp (5, 2, 3)
val ~7 = powHelp (~1, 2, ~7)


(*
 * powerT : int * int -> int
 * REQUIRES: k >= 0
 * ENSURES: pow (n, k) ==> n^k (where 0^0 is defined as 1)
 *)
fun powerT (n:int, k:int) : int = powHelp (n, k, 1)


val 1 = powerT (5, 0)
val 1 = powerT (0, 0)
val 25 = powerT (5, 2)
val 1 = powerT (~1, 2)