

(*
 * @ : int list * int list -> int list
 * REQUIRES: true
 * ENSURES: a @ b ==> a list containing all and only 
 *  the elements of a 
 *  followed by those b, maintaining order
 *)
infix @
fun (lst1:int list) @ (lst2:int list) : int list = 
  (case lst1 of
      [] => lst2 
    | hd::tl => hd :: (tl @ lst2)
  )


val [1,2] = [1,2] @ [] 
val [1,2] = [] @ [1,2]
val [1,2,3,4] = [1,2] @ [3,4]


(*
 * reverse : int list -> int list
 * REQUIRES: true
 * ENSURES: reverse x ==> a list of all the 
 *   elments of x in reverse order
 *)
fun reverse (lst:int list) : int list =
  (case lst of 
      [] => [] 
    | hd::tl => (reverse tl) @ [hd]
  )

val [] = reverse [] 
val [1] = reverse [1]
val [3,2,1] = reverse [1,2,3]